import {
	inject,
	observer,
} from 'mobx-react'
import {
	toJS
} from 'mobx'
import {
	WeaFormItem,
	WeaRightMenu,
} from 'ecCom'
import {
	Spin,
} from 'antd'
import {
	WeaSwitch
} from 'comsMobx'
import {
	i18n
} from '../../public/i18n';

@inject('hrmAssItem')
@observer
export default class FormInfo extends React.Component {
	constructor(props) {
		super(props);
	}

	componentDidMount() {
		this.props.hrmAssItem.getFormInfo();
	}

	componentWillUnmount() {
		this.props.hrmAssItem.refreshFormInfo();
	}

	getForm = () => {
		const {
			hrmAssItem
		} = this.props, {
			formInfo,
		} = hrmAssItem, {
			form,
			conditions,
		} = formInfo, {
			isFormInit,
		} = form;

		let arr = [];
		isFormInit && conditions.map(c => {
			c.items.map((field, index) => {
				arr.push(<WeaFormItem ecId={`${this && this.props && this.props.ecId || ''}_WeaFormItem@z7d30h@${index}`}
                            label={`${field.label}`}
                            labelCol={{span: 6, offset: 2}}
                            wrapperCol={{span: 15}}
                            error={form.getError(field)}
                            tipPosition="bottom"
                        >
                                <WeaSwitch ecId={`${this && this.props && this.props.ecId || ''}_WeaSwitch@kjsgbp@${index}`} fieldConfig={field} form={form} formParams={form.getFormParams()} onChange={cb => this.handleChange(cb)}/>
                        </WeaFormItem>)
			})
		})
		return <div className='wea-form-item-group'>{arr}</div>
	}

	handleChange = (cb) => {}

	getDropMenuDatas = () => {
		const {
			hrmAssItem
		} = this.props, {
			formInfo
		} = hrmAssItem, {
			loading
		} = formInfo;

		const menu = [{
			key: '0',
			icon: <i className='icon-coms-Preservation' />,
			content: i18n.button.save(),
			disabled: loading,
		}];

		return menu
	}

	handleMenuClick = (key) => {
		const {
			hrmAssItem,
		} = this.props, {
			save,
		} = hrmAssItem;

		key == '0' && save();
	}

	render() {
		const {
			hrmAssItem,
		} = this.props, {
			formInfo,
		} = hrmAssItem, {
			date,
			loading,
		} = formInfo;

		return (<div style={{height: '100%'}}>
					{loading ? 	<div style={{textAlign: 'center', paddingTop: 70}}>
									<Spin ecId={`${this && this.props && this.props.ecId || ''}_Spin@llzssz`} spinning={loading}></Spin>
							   	</div>
							 : 	<WeaRightMenu ecId={`${this && this.props && this.props.ecId || ''}_WeaRightMenu@4x9zd2`} datas={this.getDropMenuDatas()} onClick={ key => this.handleMenuClick(key)}>
				                	<div className='hrm-dialog-form'>
				                	    {this.getForm()}
				                	</div>
                				</WeaRightMenu>
					}
				</div>)
	}
}